/*
* @project 西部航空APP
* @method interface前端接口配置
* @author jun.zheng
*/
//模块接口路由配置
var if_route = {
    user : {
        userLogin : "userinfo_login", //用户登录
        userquickLogin : "userinfo_smsLogin", //用户账号验证码登录
        userRegister : "userinfo_register", //注册
        getCode : "voiceVerify_sendVoice", //用户验证码voiceVerify_sendVoice  phoneSms_sendSms
        forgetPassWord : "userinfo_forgetPwd", //忘记密码
        findPassWord : "userinfo_modifyForgetPwd", //找回密码
        updatePassWord : "userinfo_modifyPwd", //修改密码
        updateuserInfo : "userinfo_modify", //修改用户资料
        getxingCode : "phoneMsg_sendSms" //行李预订联系人验证码 phoneSms_sendSms phoneMsg_sendSms
    },
    orders : {
        getMyOrders : "orders_findOrder" //我的订单
    },
    airSearch : {
        airSearchFindAir : "airSearch_findAir", //获取航班信息
        airSearchFindAirTrip : "airSearch_findAirTrip", //机票下单
        airSearchCreateOrder : "airSearch_createOrder"//支付加载请求
    },
    pay : {
        payPay : "pay_pay"//支付
    },
    auxiliary : {
        auxiliaryFindAncillarys : "auxiliary_findAncillarys"//预订辅营
    },
    passenger : {
        passengerFindPassenger : "passenger_findPassenger", //获取常用乘机人
        passengerUpPassenger : "passenger_upPassenger", //修改常用乘机人
        passengerDelPassenger : "passenger_delPassenger", //删除常用乘机人
        passengerAddPassenger : "passenger_addPassenger"//添加常用乘机人
    },
    newsInfo : {
        newsInfoGetColumnInfo : "newsInfo_getColumnInfo", //获取栏目列表
        newsInfoGetNewsInfo : "newsInfo_getNewsInfo", //获取资讯列表
        newsInfoGetOneNewsInfo : "newsInfo_getOneNewsInfo",//获取资讯详情
    },
    messageBox : {
        messageBoxSystemMessageList : "messageBox_systemMessageList", //获取系统消息列表
        messageBoxSystemMessageDetail : "messageBox_systemMessageDetail" //获取系统消息详情
    },
    flight : {
        getFlight : "airSearch_findDynamic" //航班号和时间查询
    },
    foculist : {
        getFoculist : "flightsche_findAttentionByUserId" //航班关注查询
    },
    ticket : {
        getTicket : "airSearch_ticketCheck", //机票验真查询
        getFlightTimeAll : "otaApi_focFltinfos" //全部航班查询
    },
    FocusOn : {
        getFocusOn : "flightsche_addAttention" //关注航班
    },
    FocusOff : {
        getFocusOff : "flightsche_delAttention" //取消关注航班
    },
    Recommendedtjlb : {
        getRecommendedtjlb : "money_findRecommend" //获取推荐航线列表
    },
    xinglifindid : {
        getMyxinglid : "airSearch_findTicketByIdCard" //身份证预订
    },
    xinglifind : {
        getMyxingli : "auxiliary_findList" //行李预订
    },
    luggage : {
        getLuggage : "auxiliary_createOrder" //行李下单
    },
    payPay : {
        getZhifu : "pay_pay" //行李支付                                                                                                                                                                 gao
    },
    orderDetails : {
        getOrderDetails : "orderDetails_findDetalis" //订单详情                                                                                                                                                                gao
    },
    cancelTicket : {
        getcancelTicket : "orders_cancelOrder" //取消订单 （机票）                                                                                                                                                                gao
    },    
    cancelOrder : {
        getcancelOrder : "auxiliary_auxCancel" //取消订单 （辅营）                                                                                                                                                                gao
    },
    userInfoMation : {
        qrCodeUserInfo : "qrCode_userInfo" //扫描获取个人信息                                                                                                                                                       gao
    },
    exitTicket : {
        findexitTicket : "refundTicket_refundDetail", //退机票先查询订单详情
        findexitTicketCheck : "refundTicket_refundCalculate", //退机票确认订单详情核对价格展示
        getexitTicket : "refundTicket_refundApply" //退机票
    },
    exitOrder : {
        findexitOrder : "refundTicket_refundGoodsDetail", //退副营先查询订单详情
        findexitOrderCheck : "refundTicket_refundGoodsVerify", //退副营确认订单详情核对价格展示
        getexitOrder : "refundTicket_refundGoods" //退副营
    },
    domOrInt:{
        domOrIntPassportCountry:"domOrInt_passportCountry" //查询所有国家
    },
    otaApi:{
        otaApiAfcverif:"otaApi_afcverif" //延误证明
    } 
}

//设备类型（自定义1-->IOS,2-->android）;
var deviceType = isAndroid ? 2 : 1;

//获取接口并返回前端
function getInterface(type, condition) {
    interfaceVal = setNewsInterface(type, condition);   
    ////console.log("======>");
    ////console.log(interfaceVal);
    //getHeaders();
    var headers=getHeaders();
    interfaceVal.headers=headers;

    //md5加密
    var md = getMd5(interfaceVal.transcode);
    interfaceVal.headers.token = md;    
    ////console.log(interfaceVal);
    
    return interfaceVal;
}

//资讯列表接口设置
var newsType = "";
var list = "";
function setNewsInterface(typeVal, condition) {
    switch(typeVal) {
    case "userLogin":
        //用户登录
        list = {
            "transcode" : if_route.user.userLogin,
            "content" : {
                "userMobile" : condition.username,
                "userPassword" : condition.password
            }
        };
        break;
    case "userquickLogin":
        //用户登录
        list = {
            "transcode" : if_route.user.userquickLogin,
            "content" : {
                "userMobile" : condition.username,
                "code" : condition.code
            }
        };
        break;        
    case "userRegister":
        //用户注册
        list = {
            "transcode" : if_route.user.userRegister,
            'content' : {
                'userMobile' : condition.username,
                'userPassword' : condition.password,
                'code' : condition.code,
                'userDeviceNo' : appcan.locStorage.val("userDeviceNo") || ""
            }
        };
        break;
    case "forgetPassWord":
        //忘记密码
        list = {
            "transcode" : if_route.user.forgetPassWord,
            'content' : {
                'userMobile' : condition.username,
                'code' : condition.code
            }
        };
        break;
    case "findPassWord":
        //找回密码
        list = {
            "transcode" : if_route.user.findPassWord,
            'content' : {
                'userMobile' : condition.userMobile,
                'userPassword' : condition.newpassword,
                'code' : condition.code
            }
        };
        break;
    case "updatePassWord":
        //修改密码
        list = {
            "transcode" : if_route.user.updatePassWord,
            'content' : {
                'userPassword' : condition.loadpassword,
                'newPwd' : condition.newpassword,
                'userId' : condition.userid
            }
        };
        break;
    case "updateuserInfo":
        //修改用户资料
        list = {
            "transcode" : if_route.user.updateuserInfo,
            'content' : condition
        };
        break;
    case "getCode":
        //验证码
        list = {
            "transcode" : if_route.user.getCode,
            'content' : {
                'userMobile' : condition.username,
                'optType' : condition.optType
            }
        };
        break;
    case "getMyOrders":
        //获取我的全部订单
        list = {
            "transcode" : if_route.orders.getMyOrders,
            'content' : {
                'UserId' : condition.userId,
                "type" : condition.orderType,
                "page" : condition.pageNumIndex,
                "rows" : condition.rows
            }
        };
        break;
    case "airSearchFindAir":
        //获取航班信息
        list = {
            "transcode" : if_route.airSearch.airSearchFindAir,
            'content' : {
                'beginCity' : condition.beginCity,
                'endCity' : condition.endCity,
                'beginDate' : condition.beginDate,
                'backDate' : condition.backDate,
                'type' : condition.type,
                'userId':condition.userId,
                'timeSpan':condition.timeSpan,
                'singToken':condition.singToken,                
                'cnn' : condition.cnn,
                'adt' : condition.adt,
                'inf' : condition.inf
            }
        };
        break;
    case "airSearchFindAirTrip":
        //机票下单
        list = {
            "transcode" : if_route.airSearch.airSearchFindAirTrip,
            'content' : {
                'userId' : condition.userId,
                'searchId' : condition.searchId,
                'index' : condition.index,
                'beginCity' : condition.beginCity,
                'userId':condition.userId,
                'timeSpan':condition.timeSpan,
                'singToken':condition.singToken,                
                'PiDomOrInt' : condition.PiDomOrInt
            }
        };
        break;
    case "airSearchCreateOrder":
        //支付加载请求
        list = {
            "transcode" : if_route.airSearch.airSearchCreateOrder,
            'content' : {
                'tripOptionId' : condition.tripOptionId,
                'traveler' : condition.traveler,
                'auxiliarygo' : condition.auxiliarygo,
                'auxiliaryback' : condition.auxiliaryback,
                'customer' : condition.customer,
                'IsMailTrip' : condition.IsMailTrip,
                'userId':condition.userId,
                'timeSpan':condition.timeSpan,
                'singToken':condition.singToken,                
                'userLinkMan' : condition.userLinkMan,
                'userLinkPhone' : condition.userLinkPhone,
                'userLinkEmail' : condition.userLinkEmail
            }
        };
        break;
    case "payPay":
        //支付
        list = {
            "transcode" : if_route.pay.payPay,
            'content' : condition
        };
        break;
    case "auxiliaryFindAncillarys":
        //预订辅营
        list = {
            "transcode" : if_route.auxiliary.auxiliaryFindAncillarys,
            'content' : {
                'uri' : condition.uri,
                'segmentIndex' : condition.segmentIndex
            }
        };
        break;
    case "passengerFindPassenger":
        //获取常用联系人
        list = {
            "transcode" : if_route.passenger.passengerFindPassenger,
            'content' : {
                'UserId' : condition.UserId
            }
        };
        break;
    case "passengerUpPassenger":
        //修改常用联系人
        list = {
            "transcode" : if_route.passenger.passengerUpPassenger,
            'content' : condition
        };
        break;
    case "passengerDelPassenger":
        //删除常用联系人
        list = {
            "transcode" : if_route.passenger.passengerDelPassenger,
            'content' : {
                'PiId' : condition.PiId,
                'UserId':condition.UserId
            }
        };
        break;
    case "passengerAddPassenger":
        //添加常用联系人
        list = {
            "transcode" : if_route.passenger.passengerAddPassenger,
            'content' : condition
        };
        break;
    case "newsInfoGetColumnInfo":
        //获取栏目列表
        list = {
            "transcode" : if_route.newsInfo.newsInfoGetColumnInfo,
            'content' : {

            }
        };
        break;
    case "newsInfoGetNewsInfo":
        //获取资讯列表
        if(isDefine(condition.page)){
            list = {
                "transcode" : if_route.newsInfo.newsInfoGetNewsInfo,
                'content' : {
                    "columnId" : condition.columnId,
                    "isBill" : condition.isBill,
                    "page":{
                        "pageNo":condition.page.pageNo,
                        "pageSize":condition.page.pageSize
                    }
                }
            };
        }else{
            list = {
                "transcode" : if_route.newsInfo.newsInfoGetNewsInfo,
                'content' : {
                    "columnId" : condition.columnId,
                    "isBill" : condition.isBill
                }
            };
        }
        
        break;
    case "newsInfoGetOneNewsInfo":
        //获取资讯详情
        list = {
            "transcode" : if_route.newsInfo.newsInfoGetOneNewsInfo,
            'content' : {
                "newsId" : condition.newsId
            }
        };
        break;
    case "getXingliyuding":
        //查询行李预订                                                                                                                         gao
        //alert(condition.ticketName);
        list = {
            "transcode" : if_route.xinglifind.getMyxingli,
            'content' : {
                "type" : 1,
                "passengerName" : condition.xingname,
                "ticketNO" : condition.piaohao
            }
        };
        break;
    case "getXingliyudingid":
        //查询身份证预订
        //alert(condition.ticketName);
        list = {
            "transcode" : if_route.xinglifindid.getMyxinglid,
            'content' : {
                "idCardNum" : condition.bankid,
                "userName" : condition.xingname
            }
        };
        break;
    case "getxingCode":
        //行李预订验证码
        list = {
            "transcode" : if_route.user.getxingCode,
            'content' : {
                'userMobile' : condition.username,
                'optType' : condition.optType
            }
        };
        break;
    case "getLuggage":
        //提交行李订单
        list = {
            "transcode" : if_route.luggage.getLuggage,
            'content' : condition
        };
        break;
    case "getPayPay":
        //行李支付

        list = {
            "transcode" : if_route.payPay.getZhifu,
            'content' : condition
        };
        break;
    case "getFlightTime":
        //获取航班号和时间,起降地接口

        //var type = parseInt(appcan.locStorage.val("type"));

        var type = condition.type;
        if (type == 2) {
            if (!isLogined())//用户没有登录
            {
                list = {
                    "transcode" : if_route.flight.getFlight,
                    'content' : {
                        'dep' : condition.chufas,
                        'arr' : condition.mudis,
                        'depDate' : condition.xuanzhe,
                        'airlineRadio_value' : condition.findtype
                    }
                };
            } else//用户登录了
            {
                var userInfo = JSON.parse(appcan.locStorage.val("userInfo"));
                list = {
                    "transcode" : if_route.flight.getFlight,
                    'content' : {
                        'UserId' : userInfo.userId,
                        'dep' : condition.chufas,
                        'arr' : condition.mudis,
                        'depDate' : condition.xuanzhe,
                        'airlineRadio_value' : condition.findtype
                    }
                };
            }
        } else if (type == 1) {
            if (!isLogined())//用户没有登录
            {
                list = {
                    "transcode" : if_route.flight.getFlight,
                    'content' : {
                        'fltNum' : condition.flightName,
                        'depDate' : condition.flighttime,
                        'airlineCode' : condition.hangxian,
                        'airlineRadio_value' : condition.findtype
                    }
                };
            } else//用户登录了
            {
                var userInfo = JSON.parse(appcan.locStorage.val("userInfo"));
                list = {
                    "transcode" : if_route.flight.getFlight,
                    'content' : {
                        'UserId' : userInfo.userId,
                        'fltNum' : condition.flightName,
                        'depDate' : condition.flighttime,
                        'airlineCode' : condition.hangxian,
                        'airlineRadio_value' : condition.findtype
                    }
                };
            }
        }
        break;
    case "getFlightTimeAll":
        //获取全部航班信息接口

        list = {
            "transcode" : if_route.ticket.getFlightTimeAll,
            'content' : condition
        };
        break;        
    case "getTicketTime":
        //获取机票验真接口

        list = {
            "transcode" : if_route.ticket.getTicket,
            'content' : condition
        };
        break;
    case "getFocusOn":
        //获取机票关注接口

        list = {
            "transcode" : if_route.FocusOn.getFocusOn,
            'content' : condition
        };
        break;
    case "getFocusOff":
        //获取机票取消关注接口

        list = {
            "transcode" : if_route.FocusOff.getFocusOff,
            'content' : condition
        };
        break;
    case "getRecommendedtjlb":
        //获取推荐航线列表接口

        list = {
            "transcode" : if_route.Recommendedtjlb.getRecommendedtjlb,
            'content' : condition
        };
        break;
    case "getFoculist":
        //获取用户关注列表                                                                                                                                 gao

        list = {
            "transcode" : if_route.foculist.getFoculist,
            'content' : condition
        };
        break;
    case "orderDetails":
        //获取订单详情                                                                                                                              zj

        list = {
            "transcode" : if_route.orderDetails.getOrderDetails,
            'content' : {
                'OrderType' : condition.orderType,
                'OrderId' : parseInt(condition.orderId)
            }
        };
        //console.log(JSON.stringify(list));
        break;

    case "auxiliary_auxCancel":
        //取消副营订单                                                                                                                              zj
        var userInfo = JSON.parse(appcan.locStorage.val("userInfo"));
        list = {
            'transcode' : if_route.cancelOrder.getcancelOrder,
            'content' : condition
        };
        break;
    case "cancelTicket":
        //取消机票订单                                                                                                                              gao
        var userInfo = JSON.parse(appcan.locStorage.val("userInfo"));
        list = {
            'transcode' : if_route.cancelTicket.getcancelTicket,
            'content' : condition
        };
        break;        
    case "qrCodeUserInfo":
        //扫描获取个人信息
        list = {
            'transcode' : if_route.userInfoMation.qrCodeUserInfo,
            'content' : {
                'userId' : condition.userId
            }
        };
        break;   
    case "messageBoxSystemMessageList":
        //扫描获取个人信息
        list = {
            'transcode' : if_route.messageBox.messageBoxSystemMessageList,
            'content' : {
                'userId' : condition.userId,
                'rows':condition.rows,
                'page':condition.page
            }
        };
        break; 
    case "messageBoxSystemMessageDetail":
        //扫描获取个人信息
        list = {
            'transcode' : if_route.messageBox.messageBoxSystemMessageDetail,
            'content' : {
                'userId' : condition.userId,
                'messageId':condition.messageId
            }
        };
        break;         
    case "exitCalculate":
        //退票的费用计算查询
        list = {
            'transcode' : if_route.exitCalculate.getexitCalculate,
            'content' : condition
        };
        break;
    case "findexitTicket":
        //退机票查询
        list = {
            'transcode' : if_route.exitTicket.findexitTicket,
            'content' : condition
        };
        break;
    case "findexitTicketCheck":
        //退机票核对费用查询
        list = {
            'transcode' : if_route.exitTicket.findexitTicketCheck,
            'content' : condition
        };
        break;                       
    case "exitTicket":
        //退机票
        list = {
            'transcode' : if_route.exitTicket.getexitTicket,
            'content' : condition
        };
        break;
    case "findexitOrder":
        //退副营查询
        list = {
            'transcode' : if_route.exitOrder.findexitOrder,
            'content' : condition
        };
        break; 
    case "findexitOrderCheck":
        //退副营核对费用查询
        list = {
            'transcode' : if_route.exitOrder.findexitOrderCheck,
            'content' : condition
        };
        break;                
    case "exitOrder":
        //退副营
        list = {
            'transcode' : if_route.exitOrder.getexitOrder,
            'content' : condition
        };
        break;   
    case "domOrInt":
        //查询所有国家
        list = {
            'transcode' : if_route.domOrInt.domOrIntPassportCountry,
            'content' : {}
        };
        break;  
    case "otaApiAfcverif":
        //查询所有国家
        list = {
            'transcode' : if_route.otaApi.otaApiAfcverif,
            'content' : condition
        };
        break;                    
    }
    return list;
}

