/*
 * @project 日历选择器 hdps.datePicker
 * @method hdps_datePicker(type,aniType,cb)
 * @author jun.zheng
 * @tips 功能方法初始默认执行 
 *      type int 第一个参数表示 0-单程 或 1-往返
 *      aniType int 第二个参数为动画编号
 *      cb Function 第三个参数为回调函数
 */

    //判断当前年份是否是闰年(闰年2月份有29天，平年2月份只有28天) 能被4整除却不能被100整除 或 能被400整除的年份是闰年
    function isLeap(year) {
        return year % 4 == 0 ? (year % 100 != 0 ? 1 : (year % 400 == 0 ? 1 : 0)) : 0;
    }
    
    var today=new Date();
    var today_year = today.getFullYear();
    var today_month = today.getMonth();
    var datePicker=function(dateTimeVal,type,goOrback,initDate){
      var i, k,
      _today = dateTimeVal,   //获取当前日期
      
      y = _today.getFullYear(),   //获取日期中的年份
      
      m = _today.getMonth(),    //获取日期中的月份(需要注意的是：月份是从0开始计算，获取的值比正常月份的值少1)
      
      d = _today.getDate(),     //获取日期中的日(方便在建立日期表格时高亮显示当天)
      
      firstday = new Date(y, m, 1),  //获取当月的第一天
      
      dayOfWeek = firstday.getDay(),    //判断第一天是星期几(返回[0-6]中的一个，0代表星期天，1代表星期一，以此类推)
      
      days_per_month = new Array(31, 28 + isLeap(y), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31),   //创建月份数组
      
      str_nums = Math.ceil((dayOfWeek + days_per_month[m]) / 7);   
       
      //确定日期表格所需的行数
      var dateDOM="";
      var temp_m=m+1;
      if(temp_m < 10){
            temp_m="0"+temp_m;
      }
      dateDOM+="<div class='center-month' id='id_"+y+"_"+temp_m+"'><p style='padding-top:0.35em;'>"+parseInt(y)+"年"+parseInt(m+1)+"月</p></div>";
      //打印表格第一行(显示星期)
      //dateDOM+="<table cellspacing='0' class='width-full bg-color-white'><tr class='weekDay'><th class='font-color-weekend'>日</th><th>一</th><th>二</th><th>三</th><th>四</th><th>五</th><th class='font-color-weekend'>六</th></tr>"; 
      dateDOM+="<table cellspacing='0' class='width-full bg-color-white'></tr>"; 
      
       //二维数组创建日期表格
       var dataDateTime="",
            dateTimeNum="";
      for (i = 0; i < str_nums; i += 1) {
          dateDOM+='<tr>';
          for (k = 0; k < 7; k++) {
              var idx = 7 * i + k;                //为每个表格创建索引,从0开始
              var date = idx - dayOfWeek + 1;          //将当月的1号与星期进行匹配
              (date <= 0 || date > days_per_month[m]) ? date = '': date = idx - dayOfWeek + 1;  //索引小于等于0或者大于月份最大值就用空表格代替
              var bMonth=(m+1),
                  bDate=date;
              if(m+1<10){
                  bMonth="0"+(m+1);
              }
              if(date<10){
                  bDate="0"+date;
              }
              dataDateTime=y+"-"+bMonth+"-"+bDate;
              dateTimeNum=y+"_"+bMonth+"_"+bDate;
              if(y==today_year && m==today_month){ //当前余月
                  if(date == d){ //默认高亮显示当天
                      //dateDOM+=('<td class="goDay center-day">' + date + '<p class="font-notice">去程</p></td>');
                      if(dataDateTime == initDate){
                          if(goOrback==0){ //单程默认选中
                              dateDOM+=('<td class="center-day font-color-weekDay" id="id_'+dateTimeNum+'" data-date="'+dataDateTime+'" data-ispast="0" data-istoday="1"><p class="date-text air-init">' + date + '</p><p class="date-text02">今天</p></td>');
                          }else{ //往返
                              dateDOM+=('<td class="center-day font-color-weekDay" id="id_'+dateTimeNum+'" data-date="'+dataDateTime+'" data-ispast="0" data-istoday="1"><p class="date-text">' + date + '</p><p class="date-text02">今天</p></td>');
                          }
                      }else{
                          dateDOM+=('<td class="center-day font-color-weekDay" id="id_'+dateTimeNum+'" data-date="'+dataDateTime+'" data-ispast="0" data-istoday="1"><p class="date-text">' + date + '</p><p class="date-text02">今天</p></td>');
                      }
                  }else if(dataDateTime == initDate){//设置选中默认日期
                      if(goOrback==0){ //单程默认选中
                          dateDOM+=('<td class="center-day" id="id_'+dateTimeNum+'" data-date="'+dataDateTime+'" data-ispast="0" data-isToday="0"><p class="date-text air-init">' + date + '</p></td>');
                      }else{ //往返
                          dateDOM+=('<td class="center-day" id="id_'+dateTimeNum+'" data-date="'+dataDateTime+'" data-ispast="0" data-isToday="0"><p class="date-text">' + date + '</p></td>');
                      }
                  }else if(date - d <4 && date - d >0){
                      //dateDOM+=('<td class="center-day">' + date + '<p class="font-notice price">￥1270</p></td>');
                      dateDOM+=('<td class="center-day" id="id_'+dateTimeNum+'" data-date="'+dataDateTime+'" data-ispast="0" data-isToday="0"><p class="date-text">' + date + '</p></td>');
                  }else if(date - d <0){ //过去时间和占位
                      //dateDOM+=('<td class="center-day">' + date + '<p class="font-notice price">￥1270</p></td>');
                      dateDOM+=('<td class="center-day font-color-weekend" id="id_'+dateTimeNum+'" data-date="'+dataDateTime+'" data-ispast="1" data-isToday="0"><p class="date-text">' + date + '</p></td>');
                  }else{
                      dateDOM+=('<td class="center-day" id="id_'+dateTimeNum+'" data-date="'+dataDateTime+'" data-ispast="0" data-isToday="0"><p class="date-text">' + date + '</p></td>');
                  } 
              }else{ //不在当前月
                  if(date!=''){
                      if(dataDateTime == initDate){//设置选中默认日期
                          if(goOrback==0){ //单程默认选中
                              dateDOM+=('<td class="center-day" id="id_'+dateTimeNum+'" data-date="'+dataDateTime+'" data-ispast="0" data-isToday="0"><p class="date-text air-init">' + date + '</p></td>');
                          }else{
                              dateDOM+=('<td class="center-day" id="id_'+dateTimeNum+'" data-date="'+dataDateTime+'" data-ispast="0" data-isToday="0"><p class="date-text">' + date + '</p></td>');
                          }
                      }else{
                          dateDOM+=('<td class="center-day" id="id_'+dateTimeNum+'" data-date="'+dataDateTime+'" data-ispast="0" data-isToday="0"><p class="date-text">' + date + '</p></td>');
                      }
                      
                  }else{//占位
                      dateDOM+=('<td class="center-day" data-ispast="1" data-isToday="0"><p class="date-text">' + date + '</p></td>');
                  }
              }
          }
          dateDOM+='</tr>';
      }
      
      dateDOM+='</table>';
      
      if(type===0){
          $("#datePicker").prepend(dateDOM);
      }else{
          $("#datePicker").append(dateDOM);
      }
    }
    
    /**
     * 获取上一个月
     * @date 格式为yyyy-mm-dd的日期，如：2016-10-8
     */
    function getPreMonth(date) {
        var year = date.getFullYear(); //获取当前日期的年份
        var month = date.getMonth(); //获取当前日期的月份
        var day = date.getDate(); //获取当前日期的日
        var days = new Date(year, month, 0);
        days = days.getDate(); //获取当前日期中月的天数
        var year2 = year;     
        var month2 = parseInt(month); //+1-1
        if (month2 == 0) {
            year2 = parseInt(year2) - 1;
            month2 = 12;
        }
        var day2 = day;
        var days2 = new Date(year2, month2, 0);
        days2 = days2.getDate();
        if (day2 > days2) {
            day2 = days2;
        }
        if (month2 < 10) {
            month2 = '0' + month2;
        }
        var t2 = year2 + '/' + month2 + '/' + day2;
        t2 = new Date(t2);
        return t2;
    }
    
    /**
     * 获取下一个月
     *
     * @date 格式为yyyy-mm-dd的日期，如：2016-10-8
     */        
    function getNextMonth(date) {
        var year = date.getFullYear(); //获取当前日期的年份
        var month = date.getMonth(); //获取当前日期的月份
        var day = date.getDate(); //获取当前日期的日
        var days = new Date(year, month, 0);
        days = days.getDate(); //获取当前日期中的月的天数
        var year2 = year;
        var month2 = parseInt(month) + 2;//+1+1
        if (month2 == 13) {
            year2 = parseInt(year2) + 1;
            month2 = 1;
        }
        var day2 = day;
        var days2 = new Date(year2, month2, 0);
        days2 = days2.getDate();
        if (day2 > days2) {
            day2 = days2;
        }
        if (month2 < 10) {
            month2 = '0' + month2;
        }
    
        var t2 = year2 + '/' + month2 + '/' + day2;
        t2 = new Date(t2);
        return t2;
    }
    
    
    var dateNow="",
        newMonth="",
        dateNext="",
        isLoad=0;
    var aniInit="toTop",
        aniLast="toBottom",
        contentIsShow="top_0",
        contentIsEnd="top_100";
    
    var hdps_datePicker={
        show:function(type,aniType,initDate,cb){
            
            //alert(initDate);
             if(type==0){ //只有单程初始化时间
                 initDate=initDate.date;
             }
             
             var domView=$('<div class="dateDom" id="dateDom">'
                    +'<div class="hdps-datePicker" id="hdps_datePicker">'
                       +'<div class="hdps-box hdps-box-ver">'
                           +'<div class="hdps-box hdps-box-ver" id="hdps-dateShow">'
                               //+'<div class="hdps-box first" id="first"></div>'
                                   +'<div class="hdps-box-ver">'
                                       +'<div class="datepicker" id="datePicker">'
                                       +'</div>'
                                   +'</div>'
                                   +'<div class="hdps-box last" id="last"></div>'
                           +'</div>'
                       +'</div>'
                   +'</div>'
                 +'</div>');
            // var $body=document.getElementsByTagName("body");
            // $body.innerHTML=domView;
            $(".scrollbox").append(domView);
            isLoad=1;
            
            dateNow = new Date();
            datePicker(dateNow,1,type,initDate);
            newMonth=dateNow;
            
            //需要展示的月份数 默认一年
            var showLenDate="";
            if(isDefine(initDate) && type==0){
                showLenDate=initDate;
                showLenDate=showLenDate.replace(/-/g, "/");
                showLenDate=new Date(showLenDate);
            }else{
                showLenDate=new Date();
            }
            var showLen=dateMonthBetween(dateNow,showLenDate);
            if(showLen < 11){
                showLen = 10;
            }
            
            //向前追加显示日历
            // var datePre = getPreMonth(newMonth);
            // datePicker(datePre,0,type,initDate);
            // var newMonth_pre=datePre;
            //向后追加显示日历(默认初始化显示3个月数据)
            dateNext = getNextMonth(newMonth);
            datePicker(dateNext,1,type,initDate);
            newMonth=dateNext;
            
            for(var r=0;r<showLen;r++){
                dateNext = getNextMonth(newMonth);
                datePicker(dateNext,1,type,initDate);
                newMonth=dateNext;
            }
            
            //alert(showLen);
            
            //定位到默认选择月
            if(isDefine(initDate) && type==0){
                var initDateOffectheight=0;
                var tempInitDate=initDate.split("-");
                //alert("id_"+tempInitDate[0]+"_"+tempInitDate[1]);
                initDateOffectheight = document.getElementById("id_"+tempInitDate[0]+"_"+tempInitDate[1]).offsetTop;
                $(window).scrollTop(initDateOffectheight);
            }
            
            //监听根据滚动，实时判断某个div是否显示在可视化区域内
            $(window).scroll(function() {
                var last_offTop = document.getElementById("last").offsetTop;
                var distanceLen=last_offTop-$(window).scrollTop()-$(window).height();
                
                if (last_offTop >= $(window).scrollTop() && (last_offTop < ($(window).scrollTop()+$(window).height()) || distanceLen<$(window).height())) {
                    //alert("last在可视范围");
                    dateNext = getNextMonth(newMonth);
                    datePicker(dateNext,1,type,initDate);
                    newMonth=dateNext;
                    
                    chooseTap(type,initDate,cb);
                }
                
                //向前追加显示日历
                // var first_offTop = document.getElementById("first").offsetTop;
                // if (first_offTop >= $(window).scrollTop() && first_offTop < ($(window).scrollTop()+$(window).height())) {
                    // datePre = getPreMonth(newMonth_pre);
                    // datePicker(datePre,0,type,initDate);
                    // newMonth_pre=datePre;
                // }
            });
            
            chooseTap(type,initDate,cb);
        }
    }
    
    var cbSON="",
        index=0,
        indexDate="",
        $goDom="",
        goIndex=0,
        goDate="",
        $backDom="",
        backIndex=0,
        backDate="";
    var goDomStr=$('<p class="date-text03">去</p>');
    var backDomStr=$('<p class="date-text03">返</p>');
    var iscb=0;
    
    var chooseTap = function(type,initDate,cb){
        //设置默认值
        if(isDefine(initDate)){
            if(type==0){ //单程默认选中
                var dateTimeNumInit=initDate.replace(/-/g, "");
                $goDom=$("#id_"+dateTimeNumInit);
                indexDate=initDate;
                index=1; 
            }
        }
        
        $(".center-day").tap(function(){
            
            if(iscb==1){
                return;
            }
            
            var $dom=$(this);
            var isPast=$dom.data("ispast");
            if(isPast==1){
                return;
            }
            var myDate=$dom.data("date");
            
            if(type==0){ //单程
                 if($goDom!="" && $goDom!="undefine"){
                    //$goDom.find("p").eq(0).removeClass("air-init");
                    $(".date-text").removeClass("air-init");
                    $goDom="";
                 }
                 $dom.find("p").eq(0).addClass("air-init");
                 $goDom=$dom;
                 index=1;
                 indexDate=myDate;
                 cbSON={
                     "date":indexDate
                 }
                 callBackFunc(type,cbSON,cb);
             }else if(type==1){ //往返
                 if(goDate==myDate || backDate==myDate){ //防止重复点击已选项
                     if(goDate==myDate){
                         $goDom.find("p").eq(0).removeClass("air-go");
                         $goDom.find("p").eq(1).remove();
                         goDate="";
                         goIndex=0;
                         $goDom="";
                     }else if(backDate==myDate){
                         $backDom.find("p").eq(0).removeClass("air-back");
                         $backDom.find("p").eq(1).remove();
                         backDate="";
                         backIndex=0;
                         $backDom="";
                     }
                     return;
                 }
                 
                 //alert(goDate+" "+myDate +" "+goIndex+" "+backIndex);
                 
                 if(goIndex==0 && backIndex==0){ //两个都不存在 - 设置 去
                     $dom.find("p").eq(0).addClass("air-go");
                     $dom.append(goDomStr);
                     goDate=myDate;
                     goIndex=1;
                     $goDom=$dom;
                 }else if(goIndex==1 && backIndex==1){ //两个都存在
                     var date_go=new Date(goDate.replace(/-/g, "/"));
                     var date_back=new Date(backDate.replace(/-/g, "/"));
                     var date_myDate=new Date(myDate.replace(/-/g, "/"));
                     if(date_myDate < date_go){ //修改去
                         $goDom.find("p").eq(0).removeClass("air-go");
                         $goDom.find("p").eq(1).remove();
                         $dom.find("p").eq(0).addClass("air-go");
                         $dom.append(goDomStr);
                         goDate=myDate;
                         goIndex=1;
                         $goDom=$dom;
                     }else if(date_myDate> date_back){ //修改返
                         $backDom.find("p").eq(0).removeClass("air-back");
                         $backDom.find("p").eq(1).remove();
                         $dom.find("p").eq(0).addClass("air-back");
                         $dom.append(backDomStr);
                         backDate=myDate;
                         backIndex=1;
                         $backDom=$dom;
                     }else{ //修改返(或去)
                         $backDom.find("p").eq(0).removeClass("air-back");
                         $backDom.find("p").eq(1).remove();
                         $dom.find("p").eq(0).addClass("air-back");
                         $dom.append(backDomStr);
                         backDate=myDate;
                         backIndex=1;
                         $backDom=$dom;
                     }
                     
                 }else{  //只存在其中一个
                     if(goIndex==1 && backIndex==0){ //已选定去的时间
                         var date_go=new Date(goDate.replace(/-/g, "/"));
                         var date_myDate=new Date(myDate.replace(/-/g, "/"));
                         
                         if(date_go > date_myDate){ //去返交换
                            //设定返的时间
                             $goDom.find("p").eq(0).removeClass("air-go").addClass("air-back");
                             $goDom.find("p").eq(1).remove();
                             $goDom.append(backDomStr);
                             backDate=goDate;
                             backIndex=1;
                             $backDom=$goDom;                   
                             //设定去的时间
                             $dom.find("p").eq(0).addClass("air-go");
                             $dom.append(goDomStr);
                             goDate=myDate;
                             goIndex=1;
                             $goDom=$dom;
                         }else{//设置 返
                             //设定返的时间
                             $dom.find("p").eq(0).addClass("air-back");
                             $dom.append(backDomStr);
                             backDate=myDate;
                             backIndex=1;
                             $backDom=$dom;
                         }
                     }else if(goIndex==0 && backIndex==1){ //已选定返的时间
                         var date_back=new Date(backDate.replace(/-/g, "/"));
                         var date_myDate=new Date(myDate.replace(/-/g, "/"));
                         
                         if(date_back < date_myDate){ //去返交换
                             //设定去的时间
                             $backDom.find("p").eq(0).removeClass("air-back").addClass("air-go");
                             $backDom.find("p").eq(1).remove();
                             $backDom.append(goDomStr);
                             goDate = backDate;
                             goIndex=1;
                             $goDom=$backDom;
                             
                             //设定返的时间
                             $dom.find("p").eq(0).addClass("air-back");
                             $dom.append(backDomStr);
                             backDate=myDate;
                             backIndex=1;
                             $backDom=$dom;
                         }else{//设置 - 去
                             //设定去的时间
                             $dom.find("p").eq(0).addClass("air-go");
                             $dom.append(goDomStr);
                             goDate=myDate;
                             goIndex=1;
                             $goDom=$dom;
                         }
                     }
                 }
                 
                 //选择完毕封装返回数据
                 if(goIndex==1 && backIndex==1){
                     cbSON={
                         "date":{
                             "go":goDate,
                             "back":backDate
                         }
                     }
                     callBackFunc(type,cbSON,cb);
                 }
             }
        })
    }
    
    var callBackFunc=function(type,info,cb){
        if(type==0){
            if(index==1){
                cb(info); 
                iscb=1;
            }else{
                pop.notice("请选择日期");
            }
        }else if(type==1){
            if(goIndex==1 && backIndex==1){
                 cb(info);
                 iscb=1;
             }else{
                pop.notice("请选择日期");
            }
        }
    }
    
    
