//view 业务与交互逻辑处理

//默认列表模板 templateType==0
var Coupon = loadTemplate('../mvc/templates/Coupon.html');

var CouponsView = Backbone.View.extend({
    initialize : function(option) {
        this.model.view = this;
        this.render();
    },
    template : Coupon,
    render : function() {
        if (this.template) {
            //模板填充生成DOM
            //////console.log(this.template(this.model.attributes));
            this.$el = $(this.template(this.model.attributes));

            //资讯列表model点击事件跳转详情
            var btn_key = 1;
            appcan.button(this.$el, "btn-act", function() {
                if (btn_key == 1) {
                    btn_key = 0;
                    var $orderItemObj = $(this);
                    var orderTypeVal = $orderItemObj.data("ordertype");
                    var orderStatusVal = $orderItemObj.data("orderstatus");
                    //保存详情需要的订单列表信息
                    var orderItemInfo = {
                        "orderId" : this.id,
                        "orderType" : orderTypeVal,
                        "orderStatus" : orderStatusVal
                    }
                    appcan.locStorage.setVal("orderItemInfo", orderItemInfo);

                    if (orderTypeVal == 1) {//机票订单
                        appcan.window.open("orderDetailProgress", "orderDetailProgress.html", 10);
                    } else if (orderTypeVal == 2) {//辅营订单
                        appcan.window.open("orderDetailProgress_extra", "orderDetailProgress_extra.html", 10);
                    } else {
                        pop.notice("产品正在设计中...", 3);
                    }

                    setTimeout(function() {
                        btn_key = 1;
                    }, 1000);
                }
            });

            //选择乘机人购买辅营
            appcan.button(".order-extra-btn", "", function(e) {
                if (btn_key == 1) {
                    btn_key = 0;

                    var $orderItemObj_ = $(this);
                    var orderIdVal = $orderItemObj_.data("objid");

                    var orderExtraInfo = appcan.locStorage.val("orderExtraInfo") || "";
                    if (isDefine(orderExtraInfo)) {
                        orderExtraInfo = JSON.parse(orderExtraInfo);

                        //保存预订辅营需要的订单列表信息
                        var orderItemExtraInfo = orderExtraInfo[orderIdVal];

                        ////console.log("跳转辅营需要的数据===>");
                        ////console.log(orderItemExtraInfo);

                        appcan.locStorage.val("orderItemExtraInfo", orderItemExtraInfo);
                        appcan.window.open("airDynamic_Reservation", "airDynamic_Reservation.html", 10);
                    } else {
                        pop.notice("无票号数据!", 3);
                    }

                    setTimeout(function() {
                        btn_key = 1;
                    }, 1000);

                    e.stopPropagation();
                    //终止事件冒泡
                }
            });

            //支付订单
            appcan.button(".order-pay-btn", "", function(e) {
                if (btn_key == 1) {
                    btn_key = 0;

                    var $orderItemObj_ = $(this).parent().parent(".actionType");
                    var orderIdVal = $orderItemObj_.data("objid");
                    var totalPrice = $orderItemObj_.data("totalprice");
                    var orderTypeVal = $orderItemObj_.data("ordertype");
                    var orderNo = $orderItemObj_.data("orderno");
                    if (isDefine(orderIdVal)) {
                        if (orderTypeVal == 2) {
                            var dingdanhao = {
                                "resvCode" : orderNo,
                                "totalPrice" : totalPrice
                            }
                            appcan.locStorage.val("resvCode", dingdanhao);
                            appcan.window.open("airDynamic_dingdanzhifu", "airDynamic_dingdanzhifu.html", 10);
                            //辅盈支付

                        } else if (orderTypeVal == 1) {
                            var oederPayinfo = {
                                "resvCode" : orderNo,
                                "totalPrice" : totalPrice
                            }
                            appcan.locStorage.val("oederPayinfo", oederPayinfo);
                            //订单支付信息
                            appcan.locStorage.val("orderPaytimgtype", "yes");
                            //判断是生成订单后直接支付还是 在个人订单列表跳转
                            appcan.window.open("orderPayment", "orderPayment.html", 10);
                            //机票支付
                        }
                    } else {
                        pop.notice("无票号数据!", 3);
                    }

                    setTimeout(function() {
                        btn_key = 1;
                    }, 1000);

                    e.stopPropagation();
                    //终止事件冒泡
                }
            });

            //退票
            appcan.button(".order-cancel-btn", "", function(e) {
                if (btn_key == 1) {
                    btn_key = 0;

                    pop.notice("暂未开放", 3);

                    setTimeout(function() {
                        btn_key = 1;
                    }, 1000);

                    e.stopPropagation();
                    //终止事件冒泡
                }
            });

            //取消订单
            appcan.button(".order-action-btn", "", function(e) {
                if (btn_key == 1) {
                    btn_key = 0;

                    var $orderItemObj_ = $(this).parent().parent(".actionType");
                    var orderIdVal = $orderItemObj_.data("objid");
                    var totalPrice = $orderItemObj_.data("totalprice");
                    var orderTypeVal = $orderItemObj_.data("ordertype");
                    var orderNo = $orderItemObj_.data("orderno");
                    if (isDefine(orderIdVal)) {
                        if (orderTypeVal == 2) {//取消辅盈订单
                            var orderItemInfo = {
                                "orderId" : orderIdVal,
                                "orderType" : orderTypeVal,
                                "orderStatus" : "",
                                "resvCode" : orderNo
                            }
                            appcan.locStorage.setVal("orderItemInfo", orderItemInfo);
                            pop.confirm(0, "", "确认取消当前订单？", function(data) {
                                if (data == 0) {
                                    orderDetailProgressViewObj.cancelOrder(orderItemInfo.orderType, orderItemInfo.orderId, orderItemInfo);
                                }
                            })
                        } else if (orderTypeVal == 1) {//取消机票订单 （未开放）
                        }
                    } else {
                        pop.notice("无票号数据!", 3);
                    }

                    setTimeout(function() {
                        btn_key = 1;
                    }, 1000);

                    e.stopPropagation();
                    //终止事件冒泡
                }
            });
        }
        return this;
    }
});

var CouponView = Backbone.View.extend({
    initialize : function() {
        this.listenTo(this.collection, "add", this.add);
        this.listenTo(this.collection, "remove", this.remove);
    },
    collection : new CouponCollection(),
    pageNum : 1,
    pageCount : 0,
    el : '#ordersItem_0',
    isOver : 0,
    add : function(model, options) {
        var view = new CouponsView({
            model : model
        });

        this.$el.append(view.$el);
    },
    remove : function(model) {
        model.view.remove();
    },
    load : function(type, conditions, cb) {
        var self = this;
        if (type == 0) {
            self.pageNum = 1;
            this.isOver = 0;
            //先清空页面
            self.$el = $("#ordersItem_" + conditions.orderType);
            self.$el.html("");
        } else {
            if ((self.pageNum - 1) * 10 > self.pageCount) {
                cb();
                ////console.log("超出总分条数");
                if (!this.isOver) {
                    pop.notice("暂无更多的数据", 3);
                    this.isOver = 1;
                }
                return;
            }
        }

        conditions["pageNumIndex"] = self.pageNum;
        //获取接口参数---订单列表

        var if_list = getInterface('getMyOrders', conditions);
        ////console.log(JSON.stringify(if_list));

        pop.loading();
        this.collection.fetch({
            param : if_list,
            success : function(cols, resp, options) {
                ////console.log("-->allOrdersItemView返回=====>");
                ////console.log(resp);

                //alert("===>"+JSON.stringify(resp));
                self.pageCount = resp.data.total;

                if (type == 0) {
                    if (cols.length <= 0) {
                        self.$el.html("<div class='ub-img1 yhimg font4'><div class='zanwu'>暂无优惠卷</div></div>");
                    } else {
                        self.pageNum++;
                        self.$el.find('.noInfo').remove();
                    }
                } else {
                    if (resp.length <= 0) {
                        pop.notice("暂无更多的数据", 3);
                    } else {
                        self.pageNum++;
                    }
                }

                if (cb) {
                    pop.close();
                    cb();
                }
            },
            error : function(cols, error, options) {
                if (cb) {
                    pop.close();
                    cb();
                }
                pop.notice("数据获取失败", 3);
            },
            add : true,
            remove : (type == 0) ? true : false,
            merge : true
        });
    }
});

var CouponViewObj = new CouponView();

