var quickLoginView = Backbone.View.extend({
    initialize : function() {
        //用于数据与页面进行绑定
        this.stickit();
    },
    el : 'body',
    bindings : {
        '#userName' : 'username',
        '#code':'code'
    },
    model : new quickLoginModel(),
    quickLogin : function() {
        //验证用户输入是否合法
        if (!this.model.isValid()) {
            //提示
            layer.open({
                className:"layer-notice",
                content: this.model.validationError,
                skin: 'msg',
                shade: false,
                scrollbar: false,
                time: 1 
            });
            return false;
        }
        
        pop.loading();
        this.model.save({}, {
            postUrl:appAjax.userManageUrl, //接口地址
            success : function(cols, resp, options) {
                //console.log("账号验证码登录返回的结果=====>");
                //console.log(resp);
                
                //提示
                pop.close();
                pop.notice("登录成功");
                
                //友盟数据统计上报（登录数）
                if(!isSML){
                    var system=(isAndroid?"android":"ios");
                    var eventName = "userLoginAmount";
                    var data = {"system":system};
                    var json = JSON.stringify(data);
                    uexUmeng.onEvent(eventName, json);
                    
                    var pushStatus=appcan.locStorage.val("pushStatus")||"";
                    if(isDefine(pushStatus) && pushStatus == "yes"){
                        var params = {
                            alias : resp.data.userId+""
                        };                        
                        var  jpushInfo= JSON.stringify(params); 
                        uexJPush.setAlias(jpushInfo);
                    }
                }
                
                //是否登录的唯一标识loginState
                appcan.locStorage.setVal("loginState", "yes");
                
                //保存用户相关信息
                appcan.locStorage.setVal("recentPhoneNumber",resp.data.userMobile);
                
                appcan.locStorage.setVal('userId',resp.data.userId);
                appcan.locStorage.setVal("userInfo", JSON.stringify(resp.data));
                appcan.locStorage.setVal("login_token", JSON.stringify(resp.token));
                appcan.locStorage.setVal("opt_token", JSON.stringify(resp.token));
                
                //撤销timer
                timer.clear();
                
                //广播登录信息
                setTimeout(function(){
                     appcan.window.publish("isLogined", "yes");
                     appcan.window.close(0);
                },2000);
                    
            },
            error : function(cols, error, options) {
                pop.close();
                if(isDefine(error)){ //不为 null
                    if(error == "noNetwork"){ //网络处理
                         pop.notice("请检查网络");
                    }                     
                    else if(error == "timeout"){ //超时处理
                         pop.notice("请求超时");
                    }else{ //后台错误码处理
                        if(error.flag==="4050"){
                            pop.notice("用户名或密码错误");
                        }else{
                            pop.notice("登录失败");
                        }
                    }
                }else{
                    pop.notice("登录失败");
                }
                //撤销timer
                timer.clear();
                
                //console.log("账号验证码登录失败====>");
                //console.log(error);
            }
        })
    }
});

//初始化登录View层
quickLoginViewObj = new quickLoginView();
