var registerView = Backbone.View.extend({
    initialize : function() {
        //用于数据与页面进行绑定
        this.stickit();
    },
    el : 'body',
    bindings : {
        '#userName' : 'username',
        '#code':'code',
        '#passWord' : 'password'
    },
    model : new registerModel(),
    register : function() {
        //验证用户输入是否合法
        if (!this.model.isValid()) {
            //提示
            layer.open({
                className:"layer-notice",
                content: this.model.validationError,
                skin: 'msg',
                shade: false,
                scrollbar: false,
                time: 1 
            });
            return false;
        }
        
        this.model.save({}, {
            postUrl:appAjax.userManageUrl, //接口地址
            success : function(cols, resp, options) {
                //console.log("注册成功返回的结果=====>");
                //console.log(resp);
                
                //提示
                pop.notice("恭喜你!注册成功");
                
                //友盟数据统计上报（注册数）
                if(!isSML){
                    var system=(isAndroid?"android":"ios");
                    var eventName = "userRegisterAmount";
                    var data = {"system":system};
                    var json = JSON.stringify(data);
                    uexUmeng.onEvent(eventName, json);
                }
                
                //撤销timer
                timer.clear();
                
                //广播登录信息
                setTimeout(function(){
                     appcan.window.close(-1);
                },2000);
                    
            },
            error : function(cols, error, options) {
                if(isDefine(error)){ //不为 null
                    if(error == "noNetwork"){ //网络处理
                         pop.notice("请检查网络");
                    }                     
                    else if(error == "timeout"){ //超时处理
                         pop.notice("请求超时");
                    }else{ //后台错误码处理
                        if(error.flag==="4052"){
                            pop.notice("手机号已注册");
                        }else if(error.flag==="4051"){
                            pop.notice("验证码错误");
                        }else{
                            pop.notice("注册失败");
                        }
                    }
                }else{
                    pop.notice("注册失败");
                }
                //撤销timer
                timer.clear();
                
                //console.log("注册失败====>");
                //console.log(error);
            }
        })
    }
});

//初始化登录View层
registerViewObj = new registerView();
